%est_sequential_r.m 
%est_sequential.m 
%estimates the matrices F, G, and Sigma defining the SVAR system of owrld prices and NIPA variables (Y,C,I,TBY) one at the time for 138 countries. The SVAR system is the one studied in the paper ``World Shocks, World Prices,  And Business Cycles.''
%The main output  of this program is the 138x4 variable `result'  containg  estimates of the share of the variances of the NIPA variables explained by world shocks mediated by commodity prices and the interest rate  for the 138 countries in the panel. 
% Martn Uribe, June 2016 
clear all 
warning('off')
format compact
clc

%load vdet_hp100 BP country_name readme b raw_data %added
%produced by running vdet.m in z:\joint\isom16\138cou
[raw_data]=xlsread('Datos_VAR_3.xlsx'); %added

%Agriculture
%i=3; added
i=2;
A = log(raw_data(:,i,1));

%Fuels
%i=4; %added
i=3; %added
F = log(raw_data(:,i,1));

%Metals
%i=5; added
i=4; %added
M = log(raw_data(:,i,1));

%Interest Rate
%i=6; added 
i=5 ; %added
R = log(1+raw_data(:,i,1)/100);

%HP Filter (100)
a = hpfilter(A,100);
f = hpfilter(F,100);
m = hpfilter(M,100);
r = hpfilter(R,100);

lagg([a f m r]);
p = ans(:,1:4);
p1 = ans(:,5:end);
T = size(p,1);
cons = ones(T,1);
X = [p1 cons];

b = X\p;
A = b(1:end-1,:)';
mu = p-X*b;
Sigma_mu = cov(mu);
R2p = 1-var(mu)./var(p);

nv = 5; %# of variables in SVAR
np = 4; %# of world prices 
gx = eye(nv);

%for i = 1:length(country_name); %country
%for j = 1:4; %NIPA variables
%BP{i}(:,[3 4 5 6 6+j]); %data for domestic block

% i=6;
% PIB = log(raw_data(:,i,1));
% pib = hpfilter(PIB,100);
% ans = [a(11:end) f(11:end) m(11:end) r(11:end) pib(11:end)];  

% i=9;
% C = log(raw_data(11:end,i,1));
% c = hpfilter(C,100);
% ans = [a(11:end) f(11:end) m(11:end) r(11:end) c(1:end)];  

% i=10;
% INV = log(raw_data(11:end,i,1));
% inv = hpfilter(INV,100);
% ans = [a(11:end) f(11:end) m(11:end) r(11:end) inv(1:end)];  

% i=7;
% CPI = log(raw_data(30:end,i,1));
% cpi = hpfilter(CPI,100);
% ans = [a(30:end) f(30:end) m(30:end) r(30:end) cpi(1:end)];  

i=8;
% INF = log(raw_data(31:end,i,1))
INF = raw_data(31:end,i,1)
inf = hpfilter(INF,100);
ans = [a(31:end) f(31:end) m(31:end) r(31:end) inf(1:end)];  


lagg(ans);
D = ans(:,1:nv);
D1 = ans(:,nv+1:end);
T = size(D,1)
cons = ones(T,1);
X = [D1 D(:,1:np) cons];
Y = D(:,end);
b = X\Y;
e = Y-X*b;
b = b(1:end-1,:)';
B = b(1:np);
C = b(np+1:nv);
D = b(nv+1:nv+np);

Sigma_eps = cov(e);

F = [A zeros(np,nv-np);
        D*A+B C];
G = [eye(np) zeros(np,nv-np); 
         D eye(nv-np)];
Sigma = [Sigma_mu zeros(np,nv-np);
                  zeros(nv-np,np) Sigma_eps];
%variance decomposition 
ETA = chol(G*Sigma*G','lower');
 [Vyr,Vxr,Vy,Vx]=variance_decomposition(gx,F,ETA);
%result(i,j) = sum(Vyr(1:np,end)); added
 result = sum(Vyr(1:np,end))

%vF(1:nv,1:nv,i,j) = F;
 vF(1:nv,1:nv) = F;
%vETA(1:nv,1:nv,i,j) = ETA;
 vETA(1:nv,1:nv) = ETA;

%end % for j = 1:4; %NIPA variables

%TT(i,1) = T+1; %sample size domestic block. Why add 1? Because we took lags before and lost 1 obs. 
 TT = T+1;
%disp([ num2str(round(result(i,:)*100)/100) '  ' country_name{i}])

%end % for i = 1:length(country_name)

%disp([ num2str(round(nanmedian(result)*100)/100) '  median'])

%disp([ num2str(round(mad(result,1)*100)/100) '  mad'])

%disp([ num2str(round(nanmean(result)*100)/100) '  mean'])


%save  est_sequential_r.mat vF vETA TT country_name result R2p Sigma_mu A
 save  est_sequential_r_PM.mat vF vETA TT result R2p Sigma_mu A